﻿import appModuleHandler
from NVDAObjects.IAccessible import sysListView32, IAccessible
import controlTypes
import api

#Taken from miranda32.py
class DuplicateFocusListBox(IAccessible):
	"""A list box which annoyingly fires focus events every second, even when a menu is open.
	"""

	def _get_shouldAllowIAccessibleFocusEvent(self):
		# Stop annoying duplicate focus events, which are fired even if a menu is open.
		focus = api.getFocusObject()
		focusRole = focus.role
		focusStates = focus.states
		if (self == focus or
			(focusRole == controlTypes.ROLE_MENUITEM and controlTypes.STATE_FOCUSED in focusStates) or
			(focusRole == controlTypes.ROLE_POPUPMENU and controlTypes.STATE_INVISIBLE not in focusStates)
		):
			return False
		return super(DuplicateFocusListBox, self).shouldAllowIAccessibleFocusEvent

class AppModule(appModuleHandler.AppModule):
	def chooseNVDAObjectOverlayClasses(self, obj, clsList):
		if obj.windowControlID == 1017 and obj.windowClassName == 'SysListView32':
			clsList.insert(0, DuplicateFocusListBox)